/* MonitorMode.c generated by valac 0.43.4, the Vala compiler
 * generated from MonitorMode.vala, do not modify */

/*-
 * Copyright (c) 2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>

#define DISPLAY_TYPE_MONITOR_MODE (display_monitor_mode_get_type ())
#define DISPLAY_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode))
#define DISPLAY_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))
#define DISPLAY_IS_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_IS_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_MONITOR_MODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))

typedef struct _DisplayMonitorMode DisplayMonitorMode;
typedef struct _DisplayMonitorModeClass DisplayMonitorModeClass;
typedef struct _DisplayMonitorModePrivate DisplayMonitorModePrivate;
enum  {
	DISPLAY_MONITOR_MODE_0_PROPERTY,
	DISPLAY_MONITOR_MODE_ID_PROPERTY,
	DISPLAY_MONITOR_MODE_WIDTH_PROPERTY,
	DISPLAY_MONITOR_MODE_HEIGHT_PROPERTY,
	DISPLAY_MONITOR_MODE_FREQUENCY_PROPERTY,
	DISPLAY_MONITOR_MODE_PREFERRED_SCALE_PROPERTY,
	DISPLAY_MONITOR_MODE_IS_PREFERRED_PROPERTY,
	DISPLAY_MONITOR_MODE_IS_CURRENT_PROPERTY,
	DISPLAY_MONITOR_MODE_NUM_PROPERTIES
};
static GParamSpec* display_monitor_mode_properties[DISPLAY_MONITOR_MODE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DisplayMonitorMode {
	GObject parent_instance;
	DisplayMonitorModePrivate * priv;
};

struct _DisplayMonitorModeClass {
	GObjectClass parent_class;
};

struct _DisplayMonitorModePrivate {
	gchar* _id;
	gint _width;
	gint _height;
	gdouble _frequency;
	gdouble _preferred_scale;
	gdouble* _supported_scales;
	gint _supported_scales_length1;
	gint __supported_scales_size_;
	gboolean _is_preferred;
	gboolean _is_current;
	gchar* resolution_cache;
};

static gint DisplayMonitorMode_private_offset;
static gpointer display_monitor_mode_parent_class = NULL;

GType display_monitor_mode_get_type (void) G_GNUC_CONST;
const gchar* display_monitor_mode_get_resolution (DisplayMonitorMode* self);
static gchar* display_monitor_mode_make_aspect_string (DisplayMonitorMode* self);
gint display_monitor_mode_get_width (DisplayMonitorMode* self);
gint display_monitor_mode_get_height (DisplayMonitorMode* self);
DisplayMonitorMode* display_monitor_mode_new (void);
DisplayMonitorMode* display_monitor_mode_construct (GType object_type);
const gchar* display_monitor_mode_get_id (DisplayMonitorMode* self);
void display_monitor_mode_set_id (DisplayMonitorMode* self,
                                  const gchar* value);
void display_monitor_mode_set_width (DisplayMonitorMode* self,
                                     gint value);
void display_monitor_mode_set_height (DisplayMonitorMode* self,
                                      gint value);
gdouble display_monitor_mode_get_frequency (DisplayMonitorMode* self);
void display_monitor_mode_set_frequency (DisplayMonitorMode* self,
                                         gdouble value);
gdouble display_monitor_mode_get_preferred_scale (DisplayMonitorMode* self);
void display_monitor_mode_set_preferred_scale (DisplayMonitorMode* self,
                                               gdouble value);
gdouble* display_monitor_mode_get_supported_scales (DisplayMonitorMode* self,
                                                    gint* result_length1);
void display_monitor_mode_set_supported_scales (DisplayMonitorMode* self,
                                                gdouble* value,
                                                gint value_length1);
static gdouble* _vala_array_dup10 (gdouble* self,
                            int length);
gboolean display_monitor_mode_get_is_preferred (DisplayMonitorMode* self);
void display_monitor_mode_set_is_preferred (DisplayMonitorMode* self,
                                            gboolean value);
gboolean display_monitor_mode_get_is_current (DisplayMonitorMode* self);
void display_monitor_mode_set_is_current (DisplayMonitorMode* self,
                                          gboolean value);
static void display_monitor_mode_finalize (GObject * obj);
static void _vala_display_monitor_mode_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_display_monitor_mode_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
display_monitor_mode_get_instance_private (DisplayMonitorMode* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayMonitorMode_private_offset);
}

const gchar*
display_monitor_mode_get_resolution (DisplayMonitorMode* self)
{
	const gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp10_;
#line 33 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Objects/MonitorMode.vala"
	_tmp0_ = self->priv->resolution_cache;
#line 34 "../src/Objects/MonitorMode.vala"
	if (_tmp0_ == NULL) {
#line 144 "MonitorMode.c"
		gchar* aspect = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 35 "../src/Objects/MonitorMode.vala"
		_tmp1_ = display_monitor_mode_make_aspect_string (self);
#line 35 "../src/Objects/MonitorMode.vala"
		aspect = _tmp1_;
#line 36 "../src/Objects/MonitorMode.vala"
		_tmp2_ = aspect;
#line 36 "../src/Objects/MonitorMode.vala"
		if (_tmp2_ != NULL) {
#line 156 "MonitorMode.c"
			gint _tmp3_;
			gint _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
#line 37 "../src/Objects/MonitorMode.vala"
			_tmp3_ = self->priv->_width;
#line 37 "../src/Objects/MonitorMode.vala"
			_tmp4_ = self->priv->_height;
#line 37 "../src/Objects/MonitorMode.vala"
			_tmp5_ = aspect;
#line 37 "../src/Objects/MonitorMode.vala"
			_tmp6_ = g_strdup_printf ("%u × %u (%s)", (guint) _tmp3_, (guint) _tmp4_, _tmp5_);
#line 37 "../src/Objects/MonitorMode.vala"
			_g_free0 (self->priv->resolution_cache);
#line 37 "../src/Objects/MonitorMode.vala"
			self->priv->resolution_cache = _tmp6_;
#line 173 "MonitorMode.c"
		} else {
			gint _tmp7_;
			gint _tmp8_;
			gchar* _tmp9_;
#line 39 "../src/Objects/MonitorMode.vala"
			_tmp7_ = self->priv->_width;
#line 39 "../src/Objects/MonitorMode.vala"
			_tmp8_ = self->priv->_height;
#line 39 "../src/Objects/MonitorMode.vala"
			_tmp9_ = g_strdup_printf ("%u × %u", (guint) _tmp7_, (guint) _tmp8_);
#line 39 "../src/Objects/MonitorMode.vala"
			_g_free0 (self->priv->resolution_cache);
#line 39 "../src/Objects/MonitorMode.vala"
			self->priv->resolution_cache = _tmp9_;
#line 188 "MonitorMode.c"
		}
#line 34 "../src/Objects/MonitorMode.vala"
		_g_free0 (aspect);
#line 192 "MonitorMode.c"
	}
#line 43 "../src/Objects/MonitorMode.vala"
	_tmp10_ = self->priv->resolution_cache;
#line 43 "../src/Objects/MonitorMode.vala"
	result = _tmp10_;
#line 43 "../src/Objects/MonitorMode.vala"
	return result;
#line 200 "MonitorMode.c"
}

static gchar*
display_monitor_mode_make_aspect_string (DisplayMonitorMode* self)
{
	gchar* result = NULL;
	gint ratio = 0;
	gchar* aspect = NULL;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp3_;
	gint _tmp4_;
#line 46 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/Objects/MonitorMode.vala"
	aspect = NULL;
#line 50 "../src/Objects/MonitorMode.vala"
	_tmp1_ = self->priv->_width;
#line 50 "../src/Objects/MonitorMode.vala"
	if (_tmp1_ == 0) {
#line 50 "../src/Objects/MonitorMode.vala"
		_tmp0_ = TRUE;
#line 223 "MonitorMode.c"
	} else {
		gint _tmp2_;
#line 50 "../src/Objects/MonitorMode.vala"
		_tmp2_ = self->priv->_height;
#line 50 "../src/Objects/MonitorMode.vala"
		_tmp0_ = _tmp2_ == 0;
#line 230 "MonitorMode.c"
	}
#line 50 "../src/Objects/MonitorMode.vala"
	if (_tmp0_) {
#line 51 "../src/Objects/MonitorMode.vala"
		result = NULL;
#line 51 "../src/Objects/MonitorMode.vala"
		_g_free0 (aspect);
#line 51 "../src/Objects/MonitorMode.vala"
		return result;
#line 240 "MonitorMode.c"
	}
#line 53 "../src/Objects/MonitorMode.vala"
	_tmp3_ = self->priv->_width;
#line 53 "../src/Objects/MonitorMode.vala"
	_tmp4_ = self->priv->_height;
#line 53 "../src/Objects/MonitorMode.vala"
	if (_tmp3_ > _tmp4_) {
#line 248 "MonitorMode.c"
		gint _tmp5_;
		gint _tmp6_;
#line 54 "../src/Objects/MonitorMode.vala"
		_tmp5_ = self->priv->_width;
#line 54 "../src/Objects/MonitorMode.vala"
		_tmp6_ = self->priv->_height;
#line 54 "../src/Objects/MonitorMode.vala"
		ratio = (_tmp5_ * 10) / _tmp6_;
#line 257 "MonitorMode.c"
	} else {
		gint _tmp7_;
		gint _tmp8_;
#line 56 "../src/Objects/MonitorMode.vala"
		_tmp7_ = self->priv->_height;
#line 56 "../src/Objects/MonitorMode.vala"
		_tmp8_ = self->priv->_width;
#line 56 "../src/Objects/MonitorMode.vala"
		ratio = (_tmp7_ * 10) / _tmp8_;
#line 267 "MonitorMode.c"
	}
#line 59 "../src/Objects/MonitorMode.vala"
	switch (ratio) {
#line 59 "../src/Objects/MonitorMode.vala"
		case 13:
#line 273 "MonitorMode.c"
		{
			gchar* _tmp9_;
#line 61 "../src/Objects/MonitorMode.vala"
			_tmp9_ = g_strdup ("4∶3");
#line 61 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 61 "../src/Objects/MonitorMode.vala"
			aspect = _tmp9_;
#line 62 "../src/Objects/MonitorMode.vala"
			break;
#line 284 "MonitorMode.c"
		}
#line 59 "../src/Objects/MonitorMode.vala"
		case 16:
#line 288 "MonitorMode.c"
		{
			gchar* _tmp10_;
#line 64 "../src/Objects/MonitorMode.vala"
			_tmp10_ = g_strdup ("16∶10");
#line 64 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 64 "../src/Objects/MonitorMode.vala"
			aspect = _tmp10_;
#line 65 "../src/Objects/MonitorMode.vala"
			break;
#line 299 "MonitorMode.c"
		}
#line 59 "../src/Objects/MonitorMode.vala"
		case 17:
#line 303 "MonitorMode.c"
		{
			gchar* _tmp11_;
#line 67 "../src/Objects/MonitorMode.vala"
			_tmp11_ = g_strdup ("16∶9");
#line 67 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 67 "../src/Objects/MonitorMode.vala"
			aspect = _tmp11_;
#line 68 "../src/Objects/MonitorMode.vala"
			break;
#line 314 "MonitorMode.c"
		}
#line 59 "../src/Objects/MonitorMode.vala"
		case 23:
#line 318 "MonitorMode.c"
		{
			gchar* _tmp12_;
#line 70 "../src/Objects/MonitorMode.vala"
			_tmp12_ = g_strdup ("21∶9");
#line 70 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 70 "../src/Objects/MonitorMode.vala"
			aspect = _tmp12_;
#line 71 "../src/Objects/MonitorMode.vala"
			break;
#line 329 "MonitorMode.c"
		}
#line 59 "../src/Objects/MonitorMode.vala"
		case 12:
#line 333 "MonitorMode.c"
		{
			gchar* _tmp13_;
#line 73 "../src/Objects/MonitorMode.vala"
			_tmp13_ = g_strdup ("5∶4");
#line 73 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 73 "../src/Objects/MonitorMode.vala"
			aspect = _tmp13_;
#line 74 "../src/Objects/MonitorMode.vala"
			break;
#line 344 "MonitorMode.c"
		}
#line 59 "../src/Objects/MonitorMode.vala"
		case 15:
#line 348 "MonitorMode.c"
		{
			gchar* _tmp14_;
#line 77 "../src/Objects/MonitorMode.vala"
			_tmp14_ = g_strdup ("3∶2");
#line 77 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 77 "../src/Objects/MonitorMode.vala"
			aspect = _tmp14_;
#line 78 "../src/Objects/MonitorMode.vala"
			break;
#line 359 "MonitorMode.c"
		}
#line 59 "../src/Objects/MonitorMode.vala"
		case 18:
#line 363 "MonitorMode.c"
		{
			gchar* _tmp15_;
#line 80 "../src/Objects/MonitorMode.vala"
			_tmp15_ = g_strdup ("9∶5");
#line 80 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 80 "../src/Objects/MonitorMode.vala"
			aspect = _tmp15_;
#line 81 "../src/Objects/MonitorMode.vala"
			break;
#line 374 "MonitorMode.c"
		}
#line 59 "../src/Objects/MonitorMode.vala"
		case 10:
#line 378 "MonitorMode.c"
		{
			gchar* _tmp16_;
#line 83 "../src/Objects/MonitorMode.vala"
			_tmp16_ = g_strdup ("1∶1");
#line 83 "../src/Objects/MonitorMode.vala"
			_g_free0 (aspect);
#line 83 "../src/Objects/MonitorMode.vala"
			aspect = _tmp16_;
#line 84 "../src/Objects/MonitorMode.vala"
			break;
#line 389 "MonitorMode.c"
		}
		default:
#line 59 "../src/Objects/MonitorMode.vala"
		break;
#line 394 "MonitorMode.c"
	}
#line 87 "../src/Objects/MonitorMode.vala"
	result = aspect;
#line 87 "../src/Objects/MonitorMode.vala"
	return result;
#line 400 "MonitorMode.c"
}

DisplayMonitorMode*
display_monitor_mode_construct (GType object_type)
{
	DisplayMonitorMode * self = NULL;
#line 22 "../src/Objects/MonitorMode.vala"
	self = (DisplayMonitorMode*) g_object_new (object_type, NULL);
#line 22 "../src/Objects/MonitorMode.vala"
	return self;
#line 411 "MonitorMode.c"
}

DisplayMonitorMode*
display_monitor_mode_new (void)
{
#line 22 "../src/Objects/MonitorMode.vala"
	return display_monitor_mode_construct (DISPLAY_TYPE_MONITOR_MODE);
#line 419 "MonitorMode.c"
}

const gchar*
display_monitor_mode_get_id (DisplayMonitorMode* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Objects/MonitorMode.vala"
	_tmp0_ = self->priv->_id;
#line 23 "../src/Objects/MonitorMode.vala"
	result = _tmp0_;
#line 23 "../src/Objects/MonitorMode.vala"
	return result;
#line 435 "MonitorMode.c"
}

void
display_monitor_mode_set_id (DisplayMonitorMode* self,
                             const gchar* value)
{
#line 23 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Objects/MonitorMode.vala"
	if (g_strcmp0 (value, display_monitor_mode_get_id (self)) != 0) {
#line 446 "MonitorMode.c"
		gchar* _tmp0_;
#line 23 "../src/Objects/MonitorMode.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../src/Objects/MonitorMode.vala"
		_g_free0 (self->priv->_id);
#line 23 "../src/Objects/MonitorMode.vala"
		self->priv->_id = _tmp0_;
#line 23 "../src/Objects/MonitorMode.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_ID_PROPERTY]);
#line 456 "MonitorMode.c"
	}
}

gint
display_monitor_mode_get_width (DisplayMonitorMode* self)
{
	gint result;
#line 24 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 24 "../src/Objects/MonitorMode.vala"
	result = self->priv->_width;
#line 24 "../src/Objects/MonitorMode.vala"
	return result;
#line 470 "MonitorMode.c"
}

void
display_monitor_mode_set_width (DisplayMonitorMode* self,
                                gint value)
{
#line 24 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Objects/MonitorMode.vala"
	if (display_monitor_mode_get_width (self) != value) {
#line 24 "../src/Objects/MonitorMode.vala"
		self->priv->_width = value;
#line 24 "../src/Objects/MonitorMode.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_WIDTH_PROPERTY]);
#line 485 "MonitorMode.c"
	}
}

gint
display_monitor_mode_get_height (DisplayMonitorMode* self)
{
	gint result;
#line 25 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 25 "../src/Objects/MonitorMode.vala"
	result = self->priv->_height;
#line 25 "../src/Objects/MonitorMode.vala"
	return result;
#line 499 "MonitorMode.c"
}

void
display_monitor_mode_set_height (DisplayMonitorMode* self,
                                 gint value)
{
#line 25 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Objects/MonitorMode.vala"
	if (display_monitor_mode_get_height (self) != value) {
#line 25 "../src/Objects/MonitorMode.vala"
		self->priv->_height = value;
#line 25 "../src/Objects/MonitorMode.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_HEIGHT_PROPERTY]);
#line 514 "MonitorMode.c"
	}
}

gdouble
display_monitor_mode_get_frequency (DisplayMonitorMode* self)
{
	gdouble result;
#line 26 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 26 "../src/Objects/MonitorMode.vala"
	result = self->priv->_frequency;
#line 26 "../src/Objects/MonitorMode.vala"
	return result;
#line 528 "MonitorMode.c"
}

void
display_monitor_mode_set_frequency (DisplayMonitorMode* self,
                                    gdouble value)
{
#line 26 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Objects/MonitorMode.vala"
	if (display_monitor_mode_get_frequency (self) != value) {
#line 26 "../src/Objects/MonitorMode.vala"
		self->priv->_frequency = value;
#line 26 "../src/Objects/MonitorMode.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_FREQUENCY_PROPERTY]);
#line 543 "MonitorMode.c"
	}
}

gdouble
display_monitor_mode_get_preferred_scale (DisplayMonitorMode* self)
{
	gdouble result;
#line 27 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 27 "../src/Objects/MonitorMode.vala"
	result = self->priv->_preferred_scale;
#line 27 "../src/Objects/MonitorMode.vala"
	return result;
#line 557 "MonitorMode.c"
}

void
display_monitor_mode_set_preferred_scale (DisplayMonitorMode* self,
                                          gdouble value)
{
#line 27 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Objects/MonitorMode.vala"
	if (display_monitor_mode_get_preferred_scale (self) != value) {
#line 27 "../src/Objects/MonitorMode.vala"
		self->priv->_preferred_scale = value;
#line 27 "../src/Objects/MonitorMode.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_PREFERRED_SCALE_PROPERTY]);
#line 572 "MonitorMode.c"
	}
}

gdouble*
display_monitor_mode_get_supported_scales (DisplayMonitorMode* self,
                                           gint* result_length1)
{
	gdouble* result;
	gdouble* _tmp0_;
	gint _tmp0__length1;
	gdouble* _tmp1_;
	gint _tmp1__length1;
#line 28 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Objects/MonitorMode.vala"
	_tmp0_ = self->priv->_supported_scales;
#line 28 "../src/Objects/MonitorMode.vala"
	_tmp0__length1 = self->priv->_supported_scales_length1;
#line 28 "../src/Objects/MonitorMode.vala"
	_tmp1_ = _tmp0_;
#line 28 "../src/Objects/MonitorMode.vala"
	_tmp1__length1 = _tmp0__length1;
#line 28 "../src/Objects/MonitorMode.vala"
	if (result_length1) {
#line 28 "../src/Objects/MonitorMode.vala"
		*result_length1 = _tmp1__length1;
#line 599 "MonitorMode.c"
	}
#line 28 "../src/Objects/MonitorMode.vala"
	result = _tmp1_;
#line 28 "../src/Objects/MonitorMode.vala"
	return result;
#line 605 "MonitorMode.c"
}

static gdouble*
_vala_array_dup10 (gdouble* self,
                   int length)
{
#line 28 "../src/Objects/MonitorMode.vala"
	return g_memdup (self, length * sizeof (gdouble));
#line 614 "MonitorMode.c"
}

void
display_monitor_mode_set_supported_scales (DisplayMonitorMode* self,
                                           gdouble* value,
                                           gint value_length1)
{
	gdouble* _tmp0_;
	gint _tmp0__length1;
#line 28 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Objects/MonitorMode.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup10 (value, value_length1) : ((gpointer) value);
#line 28 "../src/Objects/MonitorMode.vala"
	_tmp0__length1 = value_length1;
#line 28 "../src/Objects/MonitorMode.vala"
	self->priv->_supported_scales = (g_free (self->priv->_supported_scales), NULL);
#line 28 "../src/Objects/MonitorMode.vala"
	self->priv->_supported_scales = _tmp0_;
#line 28 "../src/Objects/MonitorMode.vala"
	self->priv->_supported_scales_length1 = _tmp0__length1;
#line 28 "../src/Objects/MonitorMode.vala"
	self->priv->__supported_scales_size_ = self->priv->_supported_scales_length1;
#line 638 "MonitorMode.c"
}

gboolean
display_monitor_mode_get_is_preferred (DisplayMonitorMode* self)
{
	gboolean result;
#line 29 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "../src/Objects/MonitorMode.vala"
	result = self->priv->_is_preferred;
#line 29 "../src/Objects/MonitorMode.vala"
	return result;
#line 651 "MonitorMode.c"
}

void
display_monitor_mode_set_is_preferred (DisplayMonitorMode* self,
                                       gboolean value)
{
#line 29 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Objects/MonitorMode.vala"
	if (display_monitor_mode_get_is_preferred (self) != value) {
#line 29 "../src/Objects/MonitorMode.vala"
		self->priv->_is_preferred = value;
#line 29 "../src/Objects/MonitorMode.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_IS_PREFERRED_PROPERTY]);
#line 666 "MonitorMode.c"
	}
}

gboolean
display_monitor_mode_get_is_current (DisplayMonitorMode* self)
{
	gboolean result;
#line 30 "../src/Objects/MonitorMode.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 30 "../src/Objects/MonitorMode.vala"
	result = self->priv->_is_current;
#line 30 "../src/Objects/MonitorMode.vala"
	return result;
#line 680 "MonitorMode.c"
}

void
display_monitor_mode_set_is_current (DisplayMonitorMode* self,
                                     gboolean value)
{
#line 30 "../src/Objects/MonitorMode.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Objects/MonitorMode.vala"
	if (display_monitor_mode_get_is_current (self) != value) {
#line 30 "../src/Objects/MonitorMode.vala"
		self->priv->_is_current = value;
#line 30 "../src/Objects/MonitorMode.vala"
		g_object_notify_by_pspec ((GObject *) self, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_IS_CURRENT_PROPERTY]);
#line 695 "MonitorMode.c"
	}
}

static void
display_monitor_mode_class_init (DisplayMonitorModeClass * klass,
                                 gpointer klass_data)
{
#line 22 "../src/Objects/MonitorMode.vala"
	display_monitor_mode_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Objects/MonitorMode.vala"
	g_type_class_adjust_private_offset (klass, &DisplayMonitorMode_private_offset);
#line 22 "../src/Objects/MonitorMode.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_display_monitor_mode_get_property;
#line 22 "../src/Objects/MonitorMode.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_display_monitor_mode_set_property;
#line 22 "../src/Objects/MonitorMode.vala"
	G_OBJECT_CLASS (klass)->finalize = display_monitor_mode_finalize;
#line 22 "../src/Objects/MonitorMode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODE_ID_PROPERTY, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/MonitorMode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODE_WIDTH_PROPERTY, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/MonitorMode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODE_HEIGHT_PROPERTY, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/MonitorMode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODE_FREQUENCY_PROPERTY, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_FREQUENCY_PROPERTY] = g_param_spec_double ("frequency", "frequency", "frequency", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/MonitorMode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODE_PREFERRED_SCALE_PROPERTY, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_PREFERRED_SCALE_PROPERTY] = g_param_spec_double ("preferred-scale", "preferred-scale", "preferred-scale", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/MonitorMode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODE_IS_PREFERRED_PROPERTY, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_IS_PREFERRED_PROPERTY] = g_param_spec_boolean ("is-preferred", "is-preferred", "is-preferred", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/MonitorMode.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_MONITOR_MODE_IS_CURRENT_PROPERTY, display_monitor_mode_properties[DISPLAY_MONITOR_MODE_IS_CURRENT_PROPERTY] = g_param_spec_boolean ("is-current", "is-current", "is-current", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 727 "MonitorMode.c"
}

static void
display_monitor_mode_instance_init (DisplayMonitorMode * self,
                                    gpointer klass)
{
#line 22 "../src/Objects/MonitorMode.vala"
	self->priv = display_monitor_mode_get_instance_private (self);
#line 32 "../src/Objects/MonitorMode.vala"
	self->priv->resolution_cache = NULL;
#line 738 "MonitorMode.c"
}

static void
display_monitor_mode_finalize (GObject * obj)
{
	DisplayMonitorMode * self;
#line 22 "../src/Objects/MonitorMode.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode);
#line 23 "../src/Objects/MonitorMode.vala"
	_g_free0 (self->priv->_id);
#line 28 "../src/Objects/MonitorMode.vala"
	self->priv->_supported_scales = (g_free (self->priv->_supported_scales), NULL);
#line 32 "../src/Objects/MonitorMode.vala"
	_g_free0 (self->priv->resolution_cache);
#line 22 "../src/Objects/MonitorMode.vala"
	G_OBJECT_CLASS (display_monitor_mode_parent_class)->finalize (obj);
#line 755 "MonitorMode.c"
}

GType
display_monitor_mode_get_type (void)
{
	static volatile gsize display_monitor_mode_type_id__volatile = 0;
	if (g_once_init_enter (&display_monitor_mode_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DisplayMonitorModeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_monitor_mode_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayMonitorMode), 0, (GInstanceInitFunc) display_monitor_mode_instance_init, NULL };
		GType display_monitor_mode_type_id;
		display_monitor_mode_type_id = g_type_register_static (G_TYPE_OBJECT, "DisplayMonitorMode", &g_define_type_info, 0);
		DisplayMonitorMode_private_offset = g_type_add_instance_private (display_monitor_mode_type_id, sizeof (DisplayMonitorModePrivate));
		g_once_init_leave (&display_monitor_mode_type_id__volatile, display_monitor_mode_type_id);
	}
	return display_monitor_mode_type_id__volatile;
}

static void
_vala_display_monitor_mode_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	DisplayMonitorMode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode);
#line 22 "../src/Objects/MonitorMode.vala"
	switch (property_id) {
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_ID_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		g_value_set_string (value, display_monitor_mode_get_id (self));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_WIDTH_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		g_value_set_int (value, display_monitor_mode_get_width (self));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_HEIGHT_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		g_value_set_int (value, display_monitor_mode_get_height (self));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_FREQUENCY_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		g_value_set_double (value, display_monitor_mode_get_frequency (self));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_PREFERRED_SCALE_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		g_value_set_double (value, display_monitor_mode_get_preferred_scale (self));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_IS_PREFERRED_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		g_value_set_boolean (value, display_monitor_mode_get_is_preferred (self));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_IS_CURRENT_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		g_value_set_boolean (value, display_monitor_mode_get_is_current (self));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 824 "MonitorMode.c"
		default:
#line 22 "../src/Objects/MonitorMode.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 830 "MonitorMode.c"
	}
}

static void
_vala_display_monitor_mode_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	DisplayMonitorMode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode);
#line 22 "../src/Objects/MonitorMode.vala"
	switch (property_id) {
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_ID_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		display_monitor_mode_set_id (self, g_value_get_string (value));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_WIDTH_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		display_monitor_mode_set_width (self, g_value_get_int (value));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_HEIGHT_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		display_monitor_mode_set_height (self, g_value_get_int (value));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_FREQUENCY_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		display_monitor_mode_set_frequency (self, g_value_get_double (value));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_PREFERRED_SCALE_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		display_monitor_mode_set_preferred_scale (self, g_value_get_double (value));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_IS_PREFERRED_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		display_monitor_mode_set_is_preferred (self, g_value_get_boolean (value));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 22 "../src/Objects/MonitorMode.vala"
		case DISPLAY_MONITOR_MODE_IS_CURRENT_PROPERTY:
#line 22 "../src/Objects/MonitorMode.vala"
		display_monitor_mode_set_is_current (self, g_value_get_boolean (value));
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 886 "MonitorMode.c"
		default:
#line 22 "../src/Objects/MonitorMode.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Objects/MonitorMode.vala"
		break;
#line 892 "MonitorMode.c"
	}
}

