/* VirtualMonitor.c generated by valac 0.43.4, the Vala compiler
 * generated from VirtualMonitor.vala, do not modify */

/*-
 * Copyright (c) 2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define DISPLAY_TYPE_VIRTUAL_MONITOR (display_virtual_monitor_get_type ())
#define DISPLAY_VIRTUAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor))
#define DISPLAY_VIRTUAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitorClass))
#define DISPLAY_IS_VIRTUAL_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_VIRTUAL_MONITOR))
#define DISPLAY_IS_VIRTUAL_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_VIRTUAL_MONITOR))
#define DISPLAY_VIRTUAL_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitorClass))

typedef struct _DisplayVirtualMonitor DisplayVirtualMonitor;
typedef struct _DisplayVirtualMonitorClass DisplayVirtualMonitorClass;
typedef struct _DisplayVirtualMonitorPrivate DisplayVirtualMonitorPrivate;
typedef enum  {
	DISPLAY_TRANSFORM_NORMAL = 0,
	DISPLAY_TRANSFORM_ROTATION_90 = 1,
	DISPLAY_TRANSFORM_ROTATION_180 = 2,
	DISPLAY_TRANSFORM_ROTATION_270 = 3,
	DISPLAY_TRANSFORM_FLIPPED = 4,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_90 = 5,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_180 = 6,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_270 = 7
} DisplayTransform;

#define TYPE_DISPLAY_TRANSFORM (display_transform_get_type ())

#define DISPLAY_TYPE_MONITOR (display_monitor_get_type ())
#define DISPLAY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitor))
#define DISPLAY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))
#define DISPLAY_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR))
#define DISPLAY_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR))
#define DISPLAY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))

typedef struct _DisplayMonitor DisplayMonitor;
typedef struct _DisplayMonitorClass DisplayMonitorClass;
enum  {
	DISPLAY_VIRTUAL_MONITOR_0_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_X_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_ID_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_IS_MIRROR_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_IS_ACTIVE_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_MONITOR_PROPERTY,
	DISPLAY_VIRTUAL_MONITOR_NUM_PROPERTIES
};
static GParamSpec* display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DISPLAY_TYPE_MONITOR_MODE (display_monitor_mode_get_type ())
#define DISPLAY_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode))
#define DISPLAY_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))
#define DISPLAY_IS_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_IS_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_MONITOR_MODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))

typedef struct _DisplayMonitorMode DisplayMonitorMode;
typedef struct _DisplayMonitorModeClass DisplayMonitorModeClass;
typedef struct _Block2Data Block2Data;

#define TYPE_MUTTER_READ_MONITOR_INFO (mutter_read_monitor_info_get_type ())
typedef struct _MutterReadMonitorInfo MutterReadMonitorInfo;
enum  {
	DISPLAY_VIRTUAL_MONITOR_MODES_CHANGED_SIGNAL,
	DISPLAY_VIRTUAL_MONITOR_NUM_SIGNALS
};
static guint display_virtual_monitor_signals[DISPLAY_VIRTUAL_MONITOR_NUM_SIGNALS] = {0};

struct _DisplayVirtualMonitor {
	GObject parent_instance;
	DisplayVirtualMonitorPrivate * priv;
};

struct _DisplayVirtualMonitorClass {
	GObjectClass parent_class;
};

struct _DisplayVirtualMonitorPrivate {
	gint _x;
	gint _y;
	gdouble _scale;
	DisplayTransform _transform;
	gboolean _primary;
	GeeLinkedList* _monitors;
};

struct _Block2Data {
	int _ref_count_;
	DisplayVirtualMonitor* self;
	DisplayMonitorMode* current_mode;
};

struct _MutterReadMonitorInfo {
	gchar* connector;
	gchar* vendor;
	gchar* product;
	gchar* serial;
};

static gint DisplayVirtualMonitor_private_offset;
static gpointer display_virtual_monitor_parent_class = NULL;

GType display_virtual_monitor_get_type (void) G_GNUC_CONST;
GType display_transform_get_type (void) G_GNUC_CONST;
GType display_monitor_get_type (void) G_GNUC_CONST;
#define DISPLAY_VIRTUAL_MONITOR_mirrored_monitor N_ ("Mirrored Display")
DisplayVirtualMonitor* display_virtual_monitor_new (void);
DisplayVirtualMonitor* display_virtual_monitor_construct (GType object_type);
const gchar* display_virtual_monitor_get_display_name (DisplayVirtualMonitor* self);
gboolean display_virtual_monitor_get_is_mirror (DisplayVirtualMonitor* self);
DisplayMonitor* display_virtual_monitor_get_monitor (DisplayVirtualMonitor* self);
const gchar* display_monitor_get_display_name (DisplayMonitor* self);
void display_virtual_monitor_get_current_mode_size (DisplayVirtualMonitor* self,
                                                    gint* width,
                                                    gint* height);
gboolean display_virtual_monitor_get_is_active (DisplayVirtualMonitor* self);
GType display_monitor_mode_get_type (void) G_GNUC_CONST;
GeeLinkedList* display_virtual_monitor_get_monitors (DisplayVirtualMonitor* self);
DisplayMonitorMode* display_monitor_get_current_mode (DisplayMonitor* self);
gint display_monitor_mode_get_width (DisplayMonitorMode* self);
gint display_monitor_mode_get_height (DisplayMonitorMode* self);
GeeLinkedList* display_virtual_monitor_get_available_modes (DisplayVirtualMonitor* self);
GeeLinkedList* display_utils_get_common_monitor_modes (GeeLinkedList* monitors);
GeeLinkedList* display_monitor_get_modes (DisplayMonitor* self);
void display_virtual_monitor_set_current_mode (DisplayVirtualMonitor* self,
                                               DisplayMonitorMode* current_mode);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean ___lambda4_ (Block2Data* _data2_,
                      DisplayMonitor* _monitor);
void display_monitor_mode_set_is_current (DisplayMonitorMode* self,
                                          gboolean value);
static gboolean ____lambda4__gee_forall_func (gpointer g,
                                       gpointer self);
GType mutter_read_monitor_info_get_type (void) G_GNUC_CONST;
MutterReadMonitorInfo* mutter_read_monitor_info_dup (const MutterReadMonitorInfo* self);
void mutter_read_monitor_info_free (MutterReadMonitorInfo* self);
void mutter_read_monitor_info_copy (const MutterReadMonitorInfo* self,
                                    MutterReadMonitorInfo* dest);
void mutter_read_monitor_info_destroy (MutterReadMonitorInfo* self);
gchar* display_virtual_monitor_generate_id_from_monitors (MutterReadMonitorInfo* infos,
                                                          gint infos_length1);
guint mutter_read_monitor_info_get_hash (MutterReadMonitorInfo* self);
gint display_virtual_monitor_get_x (DisplayVirtualMonitor* self);
void display_virtual_monitor_set_x (DisplayVirtualMonitor* self,
                                    gint value);
gint display_virtual_monitor_get_y (DisplayVirtualMonitor* self);
void display_virtual_monitor_set_y (DisplayVirtualMonitor* self,
                                    gint value);
gdouble display_virtual_monitor_get_scale (DisplayVirtualMonitor* self);
void display_virtual_monitor_set_scale (DisplayVirtualMonitor* self,
                                        gdouble value);
DisplayTransform display_virtual_monitor_get_transform (DisplayVirtualMonitor* self);
void display_virtual_monitor_set_transform (DisplayVirtualMonitor* self,
                                            DisplayTransform value);
gboolean display_virtual_monitor_get_primary (DisplayVirtualMonitor* self);
void display_virtual_monitor_set_primary (DisplayVirtualMonitor* self,
                                          gboolean value);
static void display_virtual_monitor_set_monitors (DisplayVirtualMonitor* self,
                                           GeeLinkedList* value);
gchar* display_virtual_monitor_get_id (DisplayVirtualMonitor* self);
guint display_monitor_get_hash (DisplayMonitor* self);
static GObject * display_virtual_monitor_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties);
static void display_virtual_monitor_finalize (GObject * obj);
static void _vala_display_virtual_monitor_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_display_virtual_monitor_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

static inline gpointer
display_virtual_monitor_get_instance_private (DisplayVirtualMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayVirtualMonitor_private_offset);
}

DisplayVirtualMonitor*
display_virtual_monitor_construct (GType object_type)
{
	DisplayVirtualMonitor * self = NULL;
#line 73 "../src/Objects/VirtualMonitor.vala"
	self = (DisplayVirtualMonitor*) g_object_new (object_type, NULL);
#line 73 "../src/Objects/VirtualMonitor.vala"
	return self;
#line 224 "VirtualMonitor.c"
}

DisplayVirtualMonitor*
display_virtual_monitor_new (void)
{
#line 73 "../src/Objects/VirtualMonitor.vala"
	return display_virtual_monitor_construct (DISPLAY_TYPE_VIRTUAL_MONITOR);
#line 232 "VirtualMonitor.c"
}

const gchar*
display_virtual_monitor_get_display_name (DisplayVirtualMonitor* self)
{
	const gchar* result = NULL;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 82 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 83 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = display_virtual_monitor_get_is_mirror (self);
#line 83 "../src/Objects/VirtualMonitor.vala"
	_tmp1_ = _tmp0_;
#line 83 "../src/Objects/VirtualMonitor.vala"
	if (_tmp1_) {
#line 84 "../src/Objects/VirtualMonitor.vala"
		result = _ (DISPLAY_VIRTUAL_MONITOR_mirrored_monitor);
#line 84 "../src/Objects/VirtualMonitor.vala"
		return result;
#line 253 "VirtualMonitor.c"
	} else {
		DisplayMonitor* _tmp2_;
		DisplayMonitor* _tmp3_;
		DisplayMonitor* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 86 "../src/Objects/VirtualMonitor.vala"
		_tmp2_ = display_virtual_monitor_get_monitor (self);
#line 86 "../src/Objects/VirtualMonitor.vala"
		_tmp3_ = _tmp2_;
#line 86 "../src/Objects/VirtualMonitor.vala"
		_tmp4_ = _tmp3_;
#line 86 "../src/Objects/VirtualMonitor.vala"
		_tmp5_ = display_monitor_get_display_name (_tmp4_);
#line 86 "../src/Objects/VirtualMonitor.vala"
		_tmp6_ = _tmp5_;
#line 86 "../src/Objects/VirtualMonitor.vala"
		_tmp7_ = _tmp6_;
#line 86 "../src/Objects/VirtualMonitor.vala"
		_g_object_unref0 (_tmp4_);
#line 86 "../src/Objects/VirtualMonitor.vala"
		result = _tmp7_;
#line 86 "../src/Objects/VirtualMonitor.vala"
		return result;
#line 279 "VirtualMonitor.c"
	}
}

void
display_virtual_monitor_get_current_mode_size (DisplayVirtualMonitor* self,
                                               gint* width,
                                               gint* height)
{
	gint _vala_width = 0;
	gint _vala_height = 0;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 90 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = display_virtual_monitor_get_is_active (self);
#line 91 "../src/Objects/VirtualMonitor.vala"
	_tmp1_ = _tmp0_;
#line 91 "../src/Objects/VirtualMonitor.vala"
	if (!_tmp1_) {
#line 92 "../src/Objects/VirtualMonitor.vala"
		_vala_width = 1280;
#line 93 "../src/Objects/VirtualMonitor.vala"
		_vala_height = 720;
#line 304 "VirtualMonitor.c"
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 94 "../src/Objects/VirtualMonitor.vala"
		_tmp2_ = display_virtual_monitor_get_is_mirror (self);
#line 94 "../src/Objects/VirtualMonitor.vala"
		_tmp3_ = _tmp2_;
#line 94 "../src/Objects/VirtualMonitor.vala"
		if (_tmp3_) {
#line 314 "VirtualMonitor.c"
			DisplayMonitorMode* current_mode = NULL;
			GeeLinkedList* _tmp4_;
			gpointer _tmp5_;
			DisplayMonitor* _tmp6_;
			DisplayMonitorMode* _tmp7_;
			DisplayMonitorMode* _tmp8_;
			DisplayMonitorMode* _tmp9_;
			DisplayMonitorMode* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			DisplayMonitorMode* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
#line 95 "../src/Objects/VirtualMonitor.vala"
			_tmp4_ = self->priv->_monitors;
#line 95 "../src/Objects/VirtualMonitor.vala"
			_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, 0);
#line 95 "../src/Objects/VirtualMonitor.vala"
			_tmp6_ = (DisplayMonitor*) _tmp5_;
#line 95 "../src/Objects/VirtualMonitor.vala"
			_tmp7_ = display_monitor_get_current_mode (_tmp6_);
#line 95 "../src/Objects/VirtualMonitor.vala"
			_tmp8_ = _tmp7_;
#line 95 "../src/Objects/VirtualMonitor.vala"
			_tmp9_ = _tmp8_;
#line 95 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (_tmp6_);
#line 95 "../src/Objects/VirtualMonitor.vala"
			current_mode = _tmp9_;
#line 96 "../src/Objects/VirtualMonitor.vala"
			_tmp10_ = current_mode;
#line 96 "../src/Objects/VirtualMonitor.vala"
			_tmp11_ = display_monitor_mode_get_width (_tmp10_);
#line 96 "../src/Objects/VirtualMonitor.vala"
			_tmp12_ = _tmp11_;
#line 96 "../src/Objects/VirtualMonitor.vala"
			_vala_width = _tmp12_;
#line 97 "../src/Objects/VirtualMonitor.vala"
			_tmp13_ = current_mode;
#line 97 "../src/Objects/VirtualMonitor.vala"
			_tmp14_ = display_monitor_mode_get_height (_tmp13_);
#line 97 "../src/Objects/VirtualMonitor.vala"
			_tmp15_ = _tmp14_;
#line 97 "../src/Objects/VirtualMonitor.vala"
			_vala_height = _tmp15_;
#line 94 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (current_mode);
#line 362 "VirtualMonitor.c"
		} else {
			DisplayMonitorMode* current_mode = NULL;
			DisplayMonitor* _tmp16_;
			DisplayMonitor* _tmp17_;
			DisplayMonitor* _tmp18_;
			DisplayMonitorMode* _tmp19_;
			DisplayMonitorMode* _tmp20_;
			DisplayMonitorMode* _tmp21_;
			DisplayMonitorMode* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
			DisplayMonitorMode* _tmp25_;
			gint _tmp26_;
			gint _tmp27_;
#line 99 "../src/Objects/VirtualMonitor.vala"
			_tmp16_ = display_virtual_monitor_get_monitor (self);
#line 99 "../src/Objects/VirtualMonitor.vala"
			_tmp17_ = _tmp16_;
#line 99 "../src/Objects/VirtualMonitor.vala"
			_tmp18_ = _tmp17_;
#line 99 "../src/Objects/VirtualMonitor.vala"
			_tmp19_ = display_monitor_get_current_mode (_tmp18_);
#line 99 "../src/Objects/VirtualMonitor.vala"
			_tmp20_ = _tmp19_;
#line 99 "../src/Objects/VirtualMonitor.vala"
			_tmp21_ = _tmp20_;
#line 99 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (_tmp18_);
#line 99 "../src/Objects/VirtualMonitor.vala"
			current_mode = _tmp21_;
#line 100 "../src/Objects/VirtualMonitor.vala"
			_tmp22_ = current_mode;
#line 100 "../src/Objects/VirtualMonitor.vala"
			_tmp23_ = display_monitor_mode_get_width (_tmp22_);
#line 100 "../src/Objects/VirtualMonitor.vala"
			_tmp24_ = _tmp23_;
#line 100 "../src/Objects/VirtualMonitor.vala"
			_vala_width = _tmp24_;
#line 101 "../src/Objects/VirtualMonitor.vala"
			_tmp25_ = current_mode;
#line 101 "../src/Objects/VirtualMonitor.vala"
			_tmp26_ = display_monitor_mode_get_height (_tmp25_);
#line 101 "../src/Objects/VirtualMonitor.vala"
			_tmp27_ = _tmp26_;
#line 101 "../src/Objects/VirtualMonitor.vala"
			_vala_height = _tmp27_;
#line 94 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (current_mode);
#line 411 "VirtualMonitor.c"
		}
	}
#line 90 "../src/Objects/VirtualMonitor.vala"
	if (width) {
#line 90 "../src/Objects/VirtualMonitor.vala"
		*width = _vala_width;
#line 418 "VirtualMonitor.c"
	}
#line 90 "../src/Objects/VirtualMonitor.vala"
	if (height) {
#line 90 "../src/Objects/VirtualMonitor.vala"
		*height = _vala_height;
#line 424 "VirtualMonitor.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 109 "../src/Objects/VirtualMonitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 433 "VirtualMonitor.c"
}

GeeLinkedList*
display_virtual_monitor_get_available_modes (DisplayVirtualMonitor* self)
{
	GeeLinkedList* result = NULL;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 105 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 106 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = display_virtual_monitor_get_is_mirror (self);
#line 106 "../src/Objects/VirtualMonitor.vala"
	_tmp1_ = _tmp0_;
#line 106 "../src/Objects/VirtualMonitor.vala"
	if (_tmp1_) {
#line 450 "VirtualMonitor.c"
		GeeLinkedList* _tmp2_;
		GeeLinkedList* _tmp3_;
#line 107 "../src/Objects/VirtualMonitor.vala"
		_tmp2_ = self->priv->_monitors;
#line 107 "../src/Objects/VirtualMonitor.vala"
		_tmp3_ = display_utils_get_common_monitor_modes (_tmp2_);
#line 107 "../src/Objects/VirtualMonitor.vala"
		result = _tmp3_;
#line 107 "../src/Objects/VirtualMonitor.vala"
		return result;
#line 461 "VirtualMonitor.c"
	} else {
		DisplayMonitor* _tmp4_;
		DisplayMonitor* _tmp5_;
		DisplayMonitor* _tmp6_;
		GeeLinkedList* _tmp7_;
		GeeLinkedList* _tmp8_;
		GeeLinkedList* _tmp9_;
		GeeLinkedList* _tmp10_;
#line 109 "../src/Objects/VirtualMonitor.vala"
		_tmp4_ = display_virtual_monitor_get_monitor (self);
#line 109 "../src/Objects/VirtualMonitor.vala"
		_tmp5_ = _tmp4_;
#line 109 "../src/Objects/VirtualMonitor.vala"
		_tmp6_ = _tmp5_;
#line 109 "../src/Objects/VirtualMonitor.vala"
		_tmp7_ = display_monitor_get_modes (_tmp6_);
#line 109 "../src/Objects/VirtualMonitor.vala"
		_tmp8_ = _tmp7_;
#line 109 "../src/Objects/VirtualMonitor.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 109 "../src/Objects/VirtualMonitor.vala"
		_tmp10_ = _tmp9_;
#line 109 "../src/Objects/VirtualMonitor.vala"
		_g_object_unref0 (_tmp6_);
#line 109 "../src/Objects/VirtualMonitor.vala"
		result = _tmp10_;
#line 109 "../src/Objects/VirtualMonitor.vala"
		return result;
#line 490 "VirtualMonitor.c"
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 113 "../src/Objects/VirtualMonitor.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 113 "../src/Objects/VirtualMonitor.vala"
	return _data2_;
#line 501 "VirtualMonitor.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 113 "../src/Objects/VirtualMonitor.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 511 "VirtualMonitor.c"
		DisplayVirtualMonitor* self;
#line 113 "../src/Objects/VirtualMonitor.vala"
		self = _data2_->self;
#line 113 "../src/Objects/VirtualMonitor.vala"
		_g_object_unref0 (_data2_->current_mode);
#line 113 "../src/Objects/VirtualMonitor.vala"
		_g_object_unref0 (self);
#line 113 "../src/Objects/VirtualMonitor.vala"
		g_slice_free (Block2Data, _data2_);
#line 521 "VirtualMonitor.c"
	}
}

static gboolean
___lambda4_ (Block2Data* _data2_,
             DisplayMonitor* _monitor)
{
	DisplayVirtualMonitor* self;
	gboolean result = FALSE;
	gboolean mode_found = FALSE;
#line 115 "../src/Objects/VirtualMonitor.vala"
	self = _data2_->self;
#line 115 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (_monitor != NULL, FALSE);
#line 116 "../src/Objects/VirtualMonitor.vala"
	mode_found = FALSE;
#line 538 "VirtualMonitor.c"
	{
		GeeLinkedList* _mode_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		GeeLinkedList* _tmp2_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _mode_index = 0;
#line 117 "../src/Objects/VirtualMonitor.vala"
		_tmp0_ = display_monitor_get_modes (_monitor);
#line 117 "../src/Objects/VirtualMonitor.vala"
		_tmp1_ = _tmp0_;
#line 117 "../src/Objects/VirtualMonitor.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 117 "../src/Objects/VirtualMonitor.vala"
		_mode_list = _tmp2_;
#line 117 "../src/Objects/VirtualMonitor.vala"
		_tmp3_ = _mode_list;
#line 117 "../src/Objects/VirtualMonitor.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 117 "../src/Objects/VirtualMonitor.vala"
		_tmp5_ = _tmp4_;
#line 117 "../src/Objects/VirtualMonitor.vala"
		_mode_size = _tmp5_;
#line 117 "../src/Objects/VirtualMonitor.vala"
		_mode_index = -1;
#line 117 "../src/Objects/VirtualMonitor.vala"
		while (TRUE) {
#line 569 "VirtualMonitor.c"
			DisplayMonitorMode* mode = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			gboolean _tmp9_ = FALSE;
			DisplayMonitorMode* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
#line 117 "../src/Objects/VirtualMonitor.vala"
			_mode_index = _mode_index + 1;
#line 117 "../src/Objects/VirtualMonitor.vala"
			if (!(_mode_index < _mode_size)) {
#line 117 "../src/Objects/VirtualMonitor.vala"
				break;
#line 585 "VirtualMonitor.c"
			}
#line 117 "../src/Objects/VirtualMonitor.vala"
			_tmp6_ = _mode_list;
#line 117 "../src/Objects/VirtualMonitor.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _mode_index);
#line 117 "../src/Objects/VirtualMonitor.vala"
			mode = (DisplayMonitorMode*) _tmp7_;
#line 118 "../src/Objects/VirtualMonitor.vala"
			if (mode_found) {
#line 595 "VirtualMonitor.c"
				DisplayMonitorMode* _tmp8_;
#line 119 "../src/Objects/VirtualMonitor.vala"
				_tmp8_ = mode;
#line 119 "../src/Objects/VirtualMonitor.vala"
				display_monitor_mode_set_is_current (_tmp8_, FALSE);
#line 120 "../src/Objects/VirtualMonitor.vala"
				_g_object_unref0 (mode);
#line 120 "../src/Objects/VirtualMonitor.vala"
				continue;
#line 605 "VirtualMonitor.c"
			}
#line 123 "../src/Objects/VirtualMonitor.vala"
			_tmp10_ = mode;
#line 123 "../src/Objects/VirtualMonitor.vala"
			_tmp11_ = display_monitor_mode_get_width (_tmp10_);
#line 123 "../src/Objects/VirtualMonitor.vala"
			_tmp12_ = _tmp11_;
#line 123 "../src/Objects/VirtualMonitor.vala"
			_tmp13_ = display_monitor_mode_get_width (_data2_->current_mode);
#line 123 "../src/Objects/VirtualMonitor.vala"
			_tmp14_ = _tmp13_;
#line 123 "../src/Objects/VirtualMonitor.vala"
			if (_tmp12_ == _tmp14_) {
#line 619 "VirtualMonitor.c"
				DisplayMonitorMode* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
#line 123 "../src/Objects/VirtualMonitor.vala"
				_tmp15_ = mode;
#line 123 "../src/Objects/VirtualMonitor.vala"
				_tmp16_ = display_monitor_mode_get_height (_tmp15_);
#line 123 "../src/Objects/VirtualMonitor.vala"
				_tmp17_ = _tmp16_;
#line 123 "../src/Objects/VirtualMonitor.vala"
				_tmp18_ = display_monitor_mode_get_height (_data2_->current_mode);
#line 123 "../src/Objects/VirtualMonitor.vala"
				_tmp19_ = _tmp18_;
#line 123 "../src/Objects/VirtualMonitor.vala"
				_tmp9_ = _tmp17_ == _tmp19_;
#line 637 "VirtualMonitor.c"
			} else {
#line 123 "../src/Objects/VirtualMonitor.vala"
				_tmp9_ = FALSE;
#line 641 "VirtualMonitor.c"
			}
#line 123 "../src/Objects/VirtualMonitor.vala"
			if (_tmp9_) {
#line 645 "VirtualMonitor.c"
				DisplayMonitorMode* _tmp20_;
#line 124 "../src/Objects/VirtualMonitor.vala"
				mode_found = TRUE;
#line 125 "../src/Objects/VirtualMonitor.vala"
				_tmp20_ = mode;
#line 125 "../src/Objects/VirtualMonitor.vala"
				display_monitor_mode_set_is_current (_tmp20_, TRUE);
#line 653 "VirtualMonitor.c"
			} else {
				DisplayMonitorMode* _tmp21_;
#line 127 "../src/Objects/VirtualMonitor.vala"
				_tmp21_ = mode;
#line 127 "../src/Objects/VirtualMonitor.vala"
				display_monitor_mode_set_is_current (_tmp21_, FALSE);
#line 660 "VirtualMonitor.c"
			}
#line 117 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (mode);
#line 664 "VirtualMonitor.c"
		}
#line 117 "../src/Objects/VirtualMonitor.vala"
		_g_object_unref0 (_mode_list);
#line 668 "VirtualMonitor.c"
	}
#line 131 "../src/Objects/VirtualMonitor.vala"
	result = TRUE;
#line 131 "../src/Objects/VirtualMonitor.vala"
	_g_object_unref0 (_monitor);
#line 131 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 676 "VirtualMonitor.c"
}

static gboolean
____lambda4__gee_forall_func (gpointer g,
                              gpointer self)
{
	gboolean result;
	result = ___lambda4_ (self, (DisplayMonitor*) g);
#line 115 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 687 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_current_mode (DisplayVirtualMonitor* self,
                                          DisplayMonitorMode* current_mode)
{
	Block2Data* _data2_;
	DisplayMonitorMode* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 113 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 113 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (current_mode != NULL);
#line 113 "../src/Objects/VirtualMonitor.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 113 "../src/Objects/VirtualMonitor.vala"
	_data2_->_ref_count_ = 1;
#line 113 "../src/Objects/VirtualMonitor.vala"
	_data2_->self = g_object_ref (self);
#line 113 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = _g_object_ref0 (current_mode);
#line 113 "../src/Objects/VirtualMonitor.vala"
	_g_object_unref0 (_data2_->current_mode);
#line 113 "../src/Objects/VirtualMonitor.vala"
	_data2_->current_mode = _tmp0_;
#line 114 "../src/Objects/VirtualMonitor.vala"
	_tmp1_ = display_virtual_monitor_get_is_mirror (self);
#line 114 "../src/Objects/VirtualMonitor.vala"
	_tmp2_ = _tmp1_;
#line 114 "../src/Objects/VirtualMonitor.vala"
	if (_tmp2_) {
#line 720 "VirtualMonitor.c"
		GeeLinkedList* _tmp3_;
#line 115 "../src/Objects/VirtualMonitor.vala"
		_tmp3_ = self->priv->_monitors;
#line 115 "../src/Objects/VirtualMonitor.vala"
		gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp3_, ____lambda4__gee_forall_func, _data2_);
#line 726 "VirtualMonitor.c"
	} else {
		{
			GeeLinkedList* _mode_list = NULL;
			DisplayMonitor* _tmp4_;
			DisplayMonitor* _tmp5_;
			DisplayMonitor* _tmp6_;
			GeeLinkedList* _tmp7_;
			GeeLinkedList* _tmp8_;
			GeeLinkedList* _tmp9_;
			GeeLinkedList* _tmp10_;
			gint _mode_size = 0;
			GeeLinkedList* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
			gint _mode_index = 0;
#line 134 "../src/Objects/VirtualMonitor.vala"
			_tmp4_ = display_virtual_monitor_get_monitor (self);
#line 134 "../src/Objects/VirtualMonitor.vala"
			_tmp5_ = _tmp4_;
#line 134 "../src/Objects/VirtualMonitor.vala"
			_tmp6_ = _tmp5_;
#line 134 "../src/Objects/VirtualMonitor.vala"
			_tmp7_ = display_monitor_get_modes (_tmp6_);
#line 134 "../src/Objects/VirtualMonitor.vala"
			_tmp8_ = _tmp7_;
#line 134 "../src/Objects/VirtualMonitor.vala"
			_tmp9_ = _g_object_ref0 (_tmp8_);
#line 134 "../src/Objects/VirtualMonitor.vala"
			_tmp10_ = _tmp9_;
#line 134 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (_tmp6_);
#line 134 "../src/Objects/VirtualMonitor.vala"
			_mode_list = _tmp10_;
#line 134 "../src/Objects/VirtualMonitor.vala"
			_tmp11_ = _mode_list;
#line 134 "../src/Objects/VirtualMonitor.vala"
			_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 134 "../src/Objects/VirtualMonitor.vala"
			_tmp13_ = _tmp12_;
#line 134 "../src/Objects/VirtualMonitor.vala"
			_mode_size = _tmp13_;
#line 134 "../src/Objects/VirtualMonitor.vala"
			_mode_index = -1;
#line 134 "../src/Objects/VirtualMonitor.vala"
			while (TRUE) {
#line 772 "VirtualMonitor.c"
				DisplayMonitorMode* mode = NULL;
				GeeLinkedList* _tmp14_;
				gpointer _tmp15_;
				DisplayMonitorMode* _tmp16_;
				DisplayMonitorMode* _tmp17_;
#line 134 "../src/Objects/VirtualMonitor.vala"
				_mode_index = _mode_index + 1;
#line 134 "../src/Objects/VirtualMonitor.vala"
				if (!(_mode_index < _mode_size)) {
#line 134 "../src/Objects/VirtualMonitor.vala"
					break;
#line 784 "VirtualMonitor.c"
				}
#line 134 "../src/Objects/VirtualMonitor.vala"
				_tmp14_ = _mode_list;
#line 134 "../src/Objects/VirtualMonitor.vala"
				_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _mode_index);
#line 134 "../src/Objects/VirtualMonitor.vala"
				mode = (DisplayMonitorMode*) _tmp15_;
#line 135 "../src/Objects/VirtualMonitor.vala"
				_tmp16_ = mode;
#line 135 "../src/Objects/VirtualMonitor.vala"
				_tmp17_ = mode;
#line 135 "../src/Objects/VirtualMonitor.vala"
				display_monitor_mode_set_is_current (_tmp16_, _tmp17_ == _data2_->current_mode);
#line 134 "../src/Objects/VirtualMonitor.vala"
				_g_object_unref0 (mode);
#line 800 "VirtualMonitor.c"
			}
#line 134 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (_mode_list);
#line 804 "VirtualMonitor.c"
		}
	}
#line 113 "../src/Objects/VirtualMonitor.vala"
	block2_data_unref (_data2_);
#line 113 "../src/Objects/VirtualMonitor.vala"
	_data2_ = NULL;
#line 811 "VirtualMonitor.c"
}

gchar*
display_virtual_monitor_generate_id_from_monitors (MutterReadMonitorInfo* infos,
                                                   gint infos_length1)
{
	gchar* result = NULL;
	guint val = 0U;
	gchar* _tmp4_;
#line 141 "../src/Objects/VirtualMonitor.vala"
	val = (guint) 0;
#line 823 "VirtualMonitor.c"
	{
		MutterReadMonitorInfo* info_collection = NULL;
		gint info_collection_length1 = 0;
		gint _info_collection_size_ = 0;
		gint info_it = 0;
#line 142 "../src/Objects/VirtualMonitor.vala"
		info_collection = infos;
#line 142 "../src/Objects/VirtualMonitor.vala"
		info_collection_length1 = infos_length1;
#line 142 "../src/Objects/VirtualMonitor.vala"
		for (info_it = 0; info_it < infos_length1; info_it = info_it + 1) {
#line 835 "VirtualMonitor.c"
			MutterReadMonitorInfo _tmp0_ = {0};
			MutterReadMonitorInfo info = {0};
#line 142 "../src/Objects/VirtualMonitor.vala"
			mutter_read_monitor_info_copy (&info_collection[info_it], &_tmp0_);
#line 142 "../src/Objects/VirtualMonitor.vala"
			info = _tmp0_;
#line 842 "VirtualMonitor.c"
			{
				MutterReadMonitorInfo _tmp1_;
				guint _tmp2_;
				guint _tmp3_;
#line 143 "../src/Objects/VirtualMonitor.vala"
				_tmp1_ = info;
#line 143 "../src/Objects/VirtualMonitor.vala"
				_tmp2_ = mutter_read_monitor_info_get_hash (&_tmp1_);
#line 143 "../src/Objects/VirtualMonitor.vala"
				_tmp3_ = _tmp2_;
#line 143 "../src/Objects/VirtualMonitor.vala"
				val += _tmp3_;
#line 142 "../src/Objects/VirtualMonitor.vala"
				mutter_read_monitor_info_destroy (&info);
#line 857 "VirtualMonitor.c"
			}
		}
	}
#line 146 "../src/Objects/VirtualMonitor.vala"
	_tmp4_ = g_strdup_printf ("%u", val);
#line 146 "../src/Objects/VirtualMonitor.vala"
	result = _tmp4_;
#line 146 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 867 "VirtualMonitor.c"
}

gint
display_virtual_monitor_get_x (DisplayVirtualMonitor* self)
{
	gint result;
#line 23 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 23 "../src/Objects/VirtualMonitor.vala"
	result = self->priv->_x;
#line 23 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 880 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_x (DisplayVirtualMonitor* self,
                               gint value)
{
#line 23 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Objects/VirtualMonitor.vala"
	if (display_virtual_monitor_get_x (self) != value) {
#line 23 "../src/Objects/VirtualMonitor.vala"
		self->priv->_x = value;
#line 23 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_X_PROPERTY]);
#line 895 "VirtualMonitor.c"
	}
}

gint
display_virtual_monitor_get_y (DisplayVirtualMonitor* self)
{
	gint result;
#line 24 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 24 "../src/Objects/VirtualMonitor.vala"
	result = self->priv->_y;
#line 24 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 909 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_y (DisplayVirtualMonitor* self,
                               gint value)
{
#line 24 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Objects/VirtualMonitor.vala"
	if (display_virtual_monitor_get_y (self) != value) {
#line 24 "../src/Objects/VirtualMonitor.vala"
		self->priv->_y = value;
#line 24 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY]);
#line 924 "VirtualMonitor.c"
	}
}

gdouble
display_virtual_monitor_get_scale (DisplayVirtualMonitor* self)
{
	gdouble result;
#line 25 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 25 "../src/Objects/VirtualMonitor.vala"
	result = self->priv->_scale;
#line 25 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 938 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_scale (DisplayVirtualMonitor* self,
                                   gdouble value)
{
#line 25 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Objects/VirtualMonitor.vala"
	if (display_virtual_monitor_get_scale (self) != value) {
#line 25 "../src/Objects/VirtualMonitor.vala"
		self->priv->_scale = value;
#line 25 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY]);
#line 953 "VirtualMonitor.c"
	}
}

DisplayTransform
display_virtual_monitor_get_transform (DisplayVirtualMonitor* self)
{
	DisplayTransform result;
	DisplayTransform _tmp0_;
#line 26 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 26 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = self->priv->_transform;
#line 26 "../src/Objects/VirtualMonitor.vala"
	result = _tmp0_;
#line 26 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 970 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_transform (DisplayVirtualMonitor* self,
                                       DisplayTransform value)
{
#line 26 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/Objects/VirtualMonitor.vala"
	if (display_virtual_monitor_get_transform (self) != value) {
#line 26 "../src/Objects/VirtualMonitor.vala"
		self->priv->_transform = value;
#line 26 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY]);
#line 985 "VirtualMonitor.c"
	}
}

gboolean
display_virtual_monitor_get_primary (DisplayVirtualMonitor* self)
{
	gboolean result;
#line 27 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27 "../src/Objects/VirtualMonitor.vala"
	result = self->priv->_primary;
#line 27 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 999 "VirtualMonitor.c"
}

void
display_virtual_monitor_set_primary (DisplayVirtualMonitor* self,
                                     gboolean value)
{
#line 27 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Objects/VirtualMonitor.vala"
	if (display_virtual_monitor_get_primary (self) != value) {
#line 27 "../src/Objects/VirtualMonitor.vala"
		self->priv->_primary = value;
#line 27 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY]);
#line 1014 "VirtualMonitor.c"
	}
}

GeeLinkedList*
display_virtual_monitor_get_monitors (DisplayVirtualMonitor* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
#line 28 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = self->priv->_monitors;
#line 28 "../src/Objects/VirtualMonitor.vala"
	result = _tmp0_;
#line 28 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1031 "VirtualMonitor.c"
}

static void
display_virtual_monitor_set_monitors (DisplayVirtualMonitor* self,
                                      GeeLinkedList* value)
{
#line 28 "../src/Objects/VirtualMonitor.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Objects/VirtualMonitor.vala"
	if (display_virtual_monitor_get_monitors (self) != value) {
#line 1042 "VirtualMonitor.c"
		GeeLinkedList* _tmp0_;
#line 28 "../src/Objects/VirtualMonitor.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 28 "../src/Objects/VirtualMonitor.vala"
		_g_object_unref0 (self->priv->_monitors);
#line 28 "../src/Objects/VirtualMonitor.vala"
		self->priv->_monitors = _tmp0_;
#line 28 "../src/Objects/VirtualMonitor.vala"
		g_object_notify_by_pspec ((GObject *) self, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY]);
#line 1052 "VirtualMonitor.c"
	}
}

gchar*
display_virtual_monitor_get_id (DisplayVirtualMonitor* self)
{
	gchar* result;
	guint val = 0U;
	gchar* _tmp10_;
#line 38 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/Objects/VirtualMonitor.vala"
	val = (guint) 0;
#line 1066 "VirtualMonitor.c"
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
#line 40 "../src/Objects/VirtualMonitor.vala"
		_tmp0_ = self->priv->_monitors;
#line 40 "../src/Objects/VirtualMonitor.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 40 "../src/Objects/VirtualMonitor.vala"
		_monitor_list = _tmp1_;
#line 40 "../src/Objects/VirtualMonitor.vala"
		_tmp2_ = _monitor_list;
#line 40 "../src/Objects/VirtualMonitor.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 40 "../src/Objects/VirtualMonitor.vala"
		_tmp4_ = _tmp3_;
#line 40 "../src/Objects/VirtualMonitor.vala"
		_monitor_size = _tmp4_;
#line 40 "../src/Objects/VirtualMonitor.vala"
		_monitor_index = -1;
#line 40 "../src/Objects/VirtualMonitor.vala"
		while (TRUE) {
#line 1094 "VirtualMonitor.c"
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			DisplayMonitor* _tmp7_;
			guint _tmp8_;
			guint _tmp9_;
#line 40 "../src/Objects/VirtualMonitor.vala"
			_monitor_index = _monitor_index + 1;
#line 40 "../src/Objects/VirtualMonitor.vala"
			if (!(_monitor_index < _monitor_size)) {
#line 40 "../src/Objects/VirtualMonitor.vala"
				break;
#line 1107 "VirtualMonitor.c"
			}
#line 40 "../src/Objects/VirtualMonitor.vala"
			_tmp5_ = _monitor_list;
#line 40 "../src/Objects/VirtualMonitor.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _monitor_index);
#line 40 "../src/Objects/VirtualMonitor.vala"
			monitor = (DisplayMonitor*) _tmp6_;
#line 41 "../src/Objects/VirtualMonitor.vala"
			_tmp7_ = monitor;
#line 41 "../src/Objects/VirtualMonitor.vala"
			_tmp8_ = display_monitor_get_hash (_tmp7_);
#line 41 "../src/Objects/VirtualMonitor.vala"
			_tmp9_ = _tmp8_;
#line 41 "../src/Objects/VirtualMonitor.vala"
			val += _tmp9_;
#line 40 "../src/Objects/VirtualMonitor.vala"
			_g_object_unref0 (monitor);
#line 1125 "VirtualMonitor.c"
		}
#line 40 "../src/Objects/VirtualMonitor.vala"
		_g_object_unref0 (_monitor_list);
#line 1129 "VirtualMonitor.c"
	}
#line 44 "../src/Objects/VirtualMonitor.vala"
	_tmp10_ = g_strdup_printf ("%u", val);
#line 44 "../src/Objects/VirtualMonitor.vala"
	result = _tmp10_;
#line 44 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1137 "VirtualMonitor.c"
}

gboolean
display_virtual_monitor_get_is_mirror (DisplayVirtualMonitor* self)
{
	gboolean result;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 49 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = self->priv->_monitors;
#line 50 "../src/Objects/VirtualMonitor.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 50 "../src/Objects/VirtualMonitor.vala"
	_tmp2_ = _tmp1_;
#line 50 "../src/Objects/VirtualMonitor.vala"
	result = _tmp2_ > 1;
#line 50 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1159 "VirtualMonitor.c"
}

gboolean
display_virtual_monitor_get_is_active (DisplayVirtualMonitor* self)
{
	gboolean result;
#line 55 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../src/Objects/VirtualMonitor.vala"
	result = TRUE;
#line 56 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1172 "VirtualMonitor.c"
}

DisplayMonitor*
display_virtual_monitor_get_monitor (DisplayVirtualMonitor* self)
{
	DisplayMonitor* result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GeeLinkedList* _tmp2_;
	gpointer _tmp3_;
#line 64 "../src/Objects/VirtualMonitor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = display_virtual_monitor_get_is_mirror (self);
#line 65 "../src/Objects/VirtualMonitor.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/Objects/VirtualMonitor.vala"
	if (_tmp1_) {
#line 66 "../src/Objects/VirtualMonitor.vala"
		g_critical ("VirtualMonitor.vala:66: Do not use Display.VirtualMonitor.monitor in a" \
" mirror context!");
#line 1193 "VirtualMonitor.c"
	}
#line 69 "../src/Objects/VirtualMonitor.vala"
	_tmp2_ = self->priv->_monitors;
#line 69 "../src/Objects/VirtualMonitor.vala"
	_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp2_, 0);
#line 69 "../src/Objects/VirtualMonitor.vala"
	result = (DisplayMonitor*) _tmp3_;
#line 69 "../src/Objects/VirtualMonitor.vala"
	return result;
#line 1203 "VirtualMonitor.c"
}

static GObject *
display_virtual_monitor_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayVirtualMonitor * self;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
#line 77 "../src/Objects/VirtualMonitor.vala"
	parent_class = G_OBJECT_CLASS (display_virtual_monitor_parent_class);
#line 77 "../src/Objects/VirtualMonitor.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 77 "../src/Objects/VirtualMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor);
#line 78 "../src/Objects/VirtualMonitor.vala"
	_tmp0_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 78 "../src/Objects/VirtualMonitor.vala"
	_tmp1_ = _tmp0_;
#line 78 "../src/Objects/VirtualMonitor.vala"
	display_virtual_monitor_set_monitors (self, _tmp1_);
#line 78 "../src/Objects/VirtualMonitor.vala"
	_g_object_unref0 (_tmp1_);
#line 77 "../src/Objects/VirtualMonitor.vala"
	return obj;
#line 1232 "VirtualMonitor.c"
}

static void
display_virtual_monitor_class_init (DisplayVirtualMonitorClass * klass,
                                    gpointer klass_data)
{
#line 22 "../src/Objects/VirtualMonitor.vala"
	display_virtual_monitor_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_type_class_adjust_private_offset (klass, &DisplayVirtualMonitor_private_offset);
#line 22 "../src/Objects/VirtualMonitor.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_display_virtual_monitor_get_property;
#line 22 "../src/Objects/VirtualMonitor.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_display_virtual_monitor_set_property;
#line 22 "../src/Objects/VirtualMonitor.vala"
	G_OBJECT_CLASS (klass)->constructor = display_virtual_monitor_constructor;
#line 22 "../src/Objects/VirtualMonitor.vala"
	G_OBJECT_CLASS (klass)->finalize = display_virtual_monitor_finalize;
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_X_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_X_PROPERTY] = g_param_spec_int ("x", "x", "x", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY] = g_param_spec_int ("y", "y", "y", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY] = g_param_spec_double ("scale", "scale", "scale", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY] = g_param_spec_enum ("transform", "transform", "transform", TYPE_DISPLAY_TRANSFORM, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY] = g_param_spec_boolean ("primary", "primary", "primary", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY] = g_param_spec_object ("monitors", "monitors", "monitors", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_ID_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_IS_MIRROR_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_IS_MIRROR_PROPERTY] = g_param_spec_boolean ("is-mirror", "is-mirror", "is-mirror", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_IS_ACTIVE_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_IS_ACTIVE_PROPERTY] = g_param_spec_boolean ("is-active", "is-active", "is-active", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_VIRTUAL_MONITOR_MONITOR_PROPERTY, display_virtual_monitor_properties[DISPLAY_VIRTUAL_MONITOR_MONITOR_PROPERTY] = g_param_spec_object ("monitor", "monitor", "monitor", DISPLAY_TYPE_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../src/Objects/VirtualMonitor.vala"
	display_virtual_monitor_signals[DISPLAY_VIRTUAL_MONITOR_MODES_CHANGED_SIGNAL] = g_signal_new ("modes-changed", DISPLAY_TYPE_VIRTUAL_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1273 "VirtualMonitor.c"
}

static void
display_virtual_monitor_instance_init (DisplayVirtualMonitor * self,
                                       gpointer klass)
{
#line 22 "../src/Objects/VirtualMonitor.vala"
	self->priv = display_virtual_monitor_get_instance_private (self);
#line 1282 "VirtualMonitor.c"
}

static void
display_virtual_monitor_finalize (GObject * obj)
{
	DisplayVirtualMonitor * self;
#line 22 "../src/Objects/VirtualMonitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor);
#line 28 "../src/Objects/VirtualMonitor.vala"
	_g_object_unref0 (self->priv->_monitors);
#line 22 "../src/Objects/VirtualMonitor.vala"
	G_OBJECT_CLASS (display_virtual_monitor_parent_class)->finalize (obj);
#line 1295 "VirtualMonitor.c"
}

GType
display_virtual_monitor_get_type (void)
{
	static volatile gsize display_virtual_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&display_virtual_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DisplayVirtualMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_virtual_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayVirtualMonitor), 0, (GInstanceInitFunc) display_virtual_monitor_instance_init, NULL };
		GType display_virtual_monitor_type_id;
		display_virtual_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "DisplayVirtualMonitor", &g_define_type_info, 0);
		DisplayVirtualMonitor_private_offset = g_type_add_instance_private (display_virtual_monitor_type_id, sizeof (DisplayVirtualMonitorPrivate));
		g_once_init_leave (&display_virtual_monitor_type_id__volatile, display_virtual_monitor_type_id);
	}
	return display_virtual_monitor_type_id__volatile;
}

static void
_vala_display_virtual_monitor_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	DisplayVirtualMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor);
#line 22 "../src/Objects/VirtualMonitor.vala"
	switch (property_id) {
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_X_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_int (value, display_virtual_monitor_get_x (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_int (value, display_virtual_monitor_get_y (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_double (value, display_virtual_monitor_get_scale (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_enum (value, display_virtual_monitor_get_transform (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_boolean (value, display_virtual_monitor_get_primary (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_object (value, display_virtual_monitor_get_monitors (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_ID_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_take_string (value, display_virtual_monitor_get_id (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_IS_MIRROR_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_boolean (value, display_virtual_monitor_get_is_mirror (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_IS_ACTIVE_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_set_boolean (value, display_virtual_monitor_get_is_active (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_MONITOR_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		g_value_take_object (value, display_virtual_monitor_get_monitor (self));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 1382 "VirtualMonitor.c"
		default:
#line 22 "../src/Objects/VirtualMonitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 1388 "VirtualMonitor.c"
	}
}

static void
_vala_display_virtual_monitor_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	DisplayVirtualMonitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_VIRTUAL_MONITOR, DisplayVirtualMonitor);
#line 22 "../src/Objects/VirtualMonitor.vala"
	switch (property_id) {
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_X_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_x (self, g_value_get_int (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_Y_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_y (self, g_value_get_int (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_SCALE_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_scale (self, g_value_get_double (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_TRANSFORM_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_transform (self, g_value_get_enum (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_PRIMARY_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_primary (self, g_value_get_boolean (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 22 "../src/Objects/VirtualMonitor.vala"
		case DISPLAY_VIRTUAL_MONITOR_MONITORS_PROPERTY:
#line 22 "../src/Objects/VirtualMonitor.vala"
		display_virtual_monitor_set_monitors (self, g_value_get_object (value));
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 1438 "VirtualMonitor.c"
		default:
#line 22 "../src/Objects/VirtualMonitor.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Objects/VirtualMonitor.vala"
		break;
#line 1444 "VirtualMonitor.c"
	}
}

