/* Utils.c generated by valac 0.43.4, the Vala compiler
 * generated from Utils.vala, do not modify */

/*-
 * Copyright (c) 2014-2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DISPLAY_TYPE_MONITOR (display_monitor_get_type ())
#define DISPLAY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitor))
#define DISPLAY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))
#define DISPLAY_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR))
#define DISPLAY_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR))
#define DISPLAY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR, DisplayMonitorClass))

typedef struct _DisplayMonitor DisplayMonitor;
typedef struct _DisplayMonitorClass DisplayMonitorClass;

#define DISPLAY_TYPE_MONITOR_MODE (display_monitor_mode_get_type ())
#define DISPLAY_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorMode))
#define DISPLAY_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))
#define DISPLAY_IS_MONITOR_MODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_IS_MONITOR_MODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DISPLAY_TYPE_MONITOR_MODE))
#define DISPLAY_MONITOR_MODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DISPLAY_TYPE_MONITOR_MODE, DisplayMonitorModeClass))

typedef struct _DisplayMonitorMode DisplayMonitorMode;
typedef struct _DisplayMonitorModeClass DisplayMonitorModeClass;

gboolean display_utils_has_touchscreen (void);
GType display_monitor_get_type (void) G_GNUC_CONST;
GType display_monitor_mode_get_type (void) G_GNUC_CONST;
GeeLinkedList* display_utils_get_common_monitor_modes (GeeLinkedList* monitors);
gdouble display_utils_get_min_compatible_scale (GeeLinkedList* monitors);
GeeLinkedList* display_monitor_get_modes (DisplayMonitor* self);
gdouble* display_monitor_mode_get_supported_scales (DisplayMonitorMode* self,
                                                    gint* result_length1);
static gboolean _vala_double_array_contains (gdouble * stack,
                                      int stack_length,
                                      const gdouble needle);
gint display_monitor_mode_get_width (DisplayMonitorMode* self);
gint display_monitor_mode_get_height (DisplayMonitorMode* self);
gdouble display_monitor_get_max_scale (DisplayMonitor* self);

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../src/Utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 75 "Utils.c"
}

gboolean
display_utils_has_touchscreen (void)
{
	gboolean result = FALSE;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
#line 24 "../src/Utils.vala"
	_tmp0_ = gdk_display_get_default ();
#line 24 "../src/Utils.vala"
	display = _tmp0_;
#line 25 "../src/Utils.vala"
	_tmp1_ = display;
#line 25 "../src/Utils.vala"
	if (_tmp1_ != NULL) {
#line 93 "Utils.c"
		GdkDeviceManager* manager = NULL;
		GdkDisplay* _tmp2_;
		GdkDeviceManager* _tmp3_;
		GdkDeviceManager* _tmp4_;
		GList* devices = NULL;
		GdkDeviceManager* _tmp5_;
		GList* _tmp6_;
		GList* _tmp7_;
#line 26 "../src/Utils.vala"
		_tmp2_ = display;
#line 26 "../src/Utils.vala"
		_tmp3_ = gdk_display_get_device_manager (_tmp2_);
#line 26 "../src/Utils.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 26 "../src/Utils.vala"
		manager = _tmp4_;
#line 27 "../src/Utils.vala"
		_tmp5_ = manager;
#line 27 "../src/Utils.vala"
		_tmp6_ = gdk_device_manager_list_devices (_tmp5_, GDK_DEVICE_TYPE_SLAVE);
#line 27 "../src/Utils.vala"
		devices = _tmp6_;
#line 28 "../src/Utils.vala"
		_tmp7_ = devices;
#line 118 "Utils.c"
		{
			GList* device_collection = NULL;
			GList* device_it = NULL;
#line 28 "../src/Utils.vala"
			device_collection = _tmp7_;
#line 28 "../src/Utils.vala"
			for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
#line 126 "Utils.c"
				GdkDevice* device = NULL;
#line 28 "../src/Utils.vala"
				device = (GdkDevice*) device_it->data;
#line 130 "Utils.c"
				{
					GdkDevice* _tmp8_;
					GdkInputSource _tmp9_;
					GdkInputSource _tmp10_;
#line 29 "../src/Utils.vala"
					_tmp8_ = device;
#line 29 "../src/Utils.vala"
					g_object_get (_tmp8_, "input-source", &_tmp9_, NULL);
#line 29 "../src/Utils.vala"
					_tmp10_ = _tmp9_;
#line 29 "../src/Utils.vala"
					if (_tmp10_ == GDK_SOURCE_TOUCHSCREEN) {
#line 30 "../src/Utils.vala"
						result = TRUE;
#line 30 "../src/Utils.vala"
						(devices == NULL) ? NULL : (devices = (g_list_free (devices), NULL));
#line 30 "../src/Utils.vala"
						_g_object_unref0 (manager);
#line 30 "../src/Utils.vala"
						return result;
#line 151 "Utils.c"
					}
				}
			}
		}
#line 25 "../src/Utils.vala"
		(devices == NULL) ? NULL : (devices = (g_list_free (devices), NULL));
#line 25 "../src/Utils.vala"
		_g_object_unref0 (manager);
#line 160 "Utils.c"
	}
#line 35 "../src/Utils.vala"
	result = FALSE;
#line 35 "../src/Utils.vala"
	return result;
#line 166 "Utils.c"
}

static gboolean
_vala_double_array_contains (gdouble * stack,
                             int stack_length,
                             const gdouble needle)
{
	int i;
#line 45 "../src/Utils.vala"
	for (i = 0; i < stack_length; i++) {
#line 45 "../src/Utils.vala"
		if (needle == stack[i]) {
#line 45 "../src/Utils.vala"
			return TRUE;
#line 181 "Utils.c"
		}
	}
#line 45 "../src/Utils.vala"
	return FALSE;
#line 186 "Utils.c"
}

GeeLinkedList*
display_utils_get_common_monitor_modes (GeeLinkedList* monitors)
{
	GeeLinkedList* result = NULL;
	GeeLinkedList* common_modes = NULL;
	GeeLinkedList* _tmp0_;
	gdouble min_scale = 0.0;
	gboolean first_monitor = FALSE;
#line 38 "../src/Utils.vala"
	g_return_val_if_fail (monitors != NULL, NULL);
#line 39 "../src/Utils.vala"
	_tmp0_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 39 "../src/Utils.vala"
	common_modes = _tmp0_;
#line 40 "../src/Utils.vala"
	min_scale = display_utils_get_min_compatible_scale (monitors);
#line 41 "../src/Utils.vala"
	first_monitor = TRUE;
#line 207 "Utils.c"
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _monitor_index = 0;
#line 42 "../src/Utils.vala"
		_tmp1_ = _g_object_ref0 (monitors);
#line 42 "../src/Utils.vala"
		_monitor_list = _tmp1_;
#line 42 "../src/Utils.vala"
		_tmp2_ = _monitor_list;
#line 42 "../src/Utils.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 42 "../src/Utils.vala"
		_tmp4_ = _tmp3_;
#line 42 "../src/Utils.vala"
		_monitor_size = _tmp4_;
#line 42 "../src/Utils.vala"
		_monitor_index = -1;
#line 42 "../src/Utils.vala"
		while (TRUE) {
#line 232 "Utils.c"
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
#line 42 "../src/Utils.vala"
			_monitor_index = _monitor_index + 1;
#line 42 "../src/Utils.vala"
			if (!(_monitor_index < _monitor_size)) {
#line 42 "../src/Utils.vala"
				break;
#line 242 "Utils.c"
			}
#line 42 "../src/Utils.vala"
			_tmp5_ = _monitor_list;
#line 42 "../src/Utils.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _monitor_index);
#line 42 "../src/Utils.vala"
			monitor = (DisplayMonitor*) _tmp6_;
#line 43 "../src/Utils.vala"
			if (first_monitor) {
#line 252 "Utils.c"
				{
					GeeLinkedList* _mode_list = NULL;
					DisplayMonitor* _tmp7_;
					GeeLinkedList* _tmp8_;
					GeeLinkedList* _tmp9_;
					GeeLinkedList* _tmp10_;
					gint _mode_size = 0;
					GeeLinkedList* _tmp11_;
					gint _tmp12_;
					gint _tmp13_;
					gint _mode_index = 0;
#line 44 "../src/Utils.vala"
					_tmp7_ = monitor;
#line 44 "../src/Utils.vala"
					_tmp8_ = display_monitor_get_modes (_tmp7_);
#line 44 "../src/Utils.vala"
					_tmp9_ = _tmp8_;
#line 44 "../src/Utils.vala"
					_tmp10_ = _g_object_ref0 (_tmp9_);
#line 44 "../src/Utils.vala"
					_mode_list = _tmp10_;
#line 44 "../src/Utils.vala"
					_tmp11_ = _mode_list;
#line 44 "../src/Utils.vala"
					_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 44 "../src/Utils.vala"
					_tmp13_ = _tmp12_;
#line 44 "../src/Utils.vala"
					_mode_size = _tmp13_;
#line 44 "../src/Utils.vala"
					_mode_index = -1;
#line 44 "../src/Utils.vala"
					while (TRUE) {
#line 286 "Utils.c"
						DisplayMonitorMode* mode = NULL;
						GeeLinkedList* _tmp14_;
						gpointer _tmp15_;
						DisplayMonitorMode* _tmp16_;
						gdouble* _tmp17_;
						gint _tmp17__length1;
						gdouble* _tmp18_;
						gint _tmp18__length1;
#line 44 "../src/Utils.vala"
						_mode_index = _mode_index + 1;
#line 44 "../src/Utils.vala"
						if (!(_mode_index < _mode_size)) {
#line 44 "../src/Utils.vala"
							break;
#line 301 "Utils.c"
						}
#line 44 "../src/Utils.vala"
						_tmp14_ = _mode_list;
#line 44 "../src/Utils.vala"
						_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _mode_index);
#line 44 "../src/Utils.vala"
						mode = (DisplayMonitorMode*) _tmp15_;
#line 45 "../src/Utils.vala"
						_tmp16_ = mode;
#line 45 "../src/Utils.vala"
						_tmp17_ = display_monitor_mode_get_supported_scales (_tmp16_, &_tmp17__length1);
#line 45 "../src/Utils.vala"
						_tmp18_ = _tmp17_;
#line 45 "../src/Utils.vala"
						_tmp18__length1 = _tmp17__length1;
#line 45 "../src/Utils.vala"
						if (_vala_double_array_contains (_tmp18_, _tmp18__length1, min_scale)) {
#line 319 "Utils.c"
							GeeLinkedList* _tmp19_;
							DisplayMonitorMode* _tmp20_;
#line 46 "../src/Utils.vala"
							_tmp19_ = common_modes;
#line 46 "../src/Utils.vala"
							_tmp20_ = mode;
#line 46 "../src/Utils.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp19_, _tmp20_);
#line 328 "Utils.c"
						}
#line 44 "../src/Utils.vala"
						_g_object_unref0 (mode);
#line 332 "Utils.c"
					}
#line 44 "../src/Utils.vala"
					_g_object_unref0 (_mode_list);
#line 336 "Utils.c"
				}
#line 50 "../src/Utils.vala"
				first_monitor = FALSE;
#line 340 "Utils.c"
			} else {
				GeeLinkedList* to_remove = NULL;
				GeeLinkedList* _tmp21_;
				GeeLinkedList* _tmp53_;
				GeeLinkedList* _tmp54_;
#line 52 "../src/Utils.vala"
				_tmp21_ = gee_linked_list_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 52 "../src/Utils.vala"
				to_remove = _tmp21_;
#line 350 "Utils.c"
				{
					GeeLinkedList* _mode_to_check_list = NULL;
					GeeLinkedList* _tmp22_;
					GeeLinkedList* _tmp23_;
					gint _mode_to_check_size = 0;
					GeeLinkedList* _tmp24_;
					gint _tmp25_;
					gint _tmp26_;
					gint _mode_to_check_index = 0;
#line 53 "../src/Utils.vala"
					_tmp22_ = common_modes;
#line 53 "../src/Utils.vala"
					_tmp23_ = _g_object_ref0 (_tmp22_);
#line 53 "../src/Utils.vala"
					_mode_to_check_list = _tmp23_;
#line 53 "../src/Utils.vala"
					_tmp24_ = _mode_to_check_list;
#line 53 "../src/Utils.vala"
					_tmp25_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp24_);
#line 53 "../src/Utils.vala"
					_tmp26_ = _tmp25_;
#line 53 "../src/Utils.vala"
					_mode_to_check_size = _tmp26_;
#line 53 "../src/Utils.vala"
					_mode_to_check_index = -1;
#line 53 "../src/Utils.vala"
					while (TRUE) {
#line 378 "Utils.c"
						DisplayMonitorMode* mode_to_check = NULL;
						GeeLinkedList* _tmp27_;
						gpointer _tmp28_;
						gboolean mode_found = FALSE;
#line 53 "../src/Utils.vala"
						_mode_to_check_index = _mode_to_check_index + 1;
#line 53 "../src/Utils.vala"
						if (!(_mode_to_check_index < _mode_to_check_size)) {
#line 53 "../src/Utils.vala"
							break;
#line 389 "Utils.c"
						}
#line 53 "../src/Utils.vala"
						_tmp27_ = _mode_to_check_list;
#line 53 "../src/Utils.vala"
						_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, _mode_to_check_index);
#line 53 "../src/Utils.vala"
						mode_to_check = (DisplayMonitorMode*) _tmp28_;
#line 54 "../src/Utils.vala"
						mode_found = FALSE;
#line 399 "Utils.c"
						{
							GeeLinkedList* _monitor_mode_list = NULL;
							DisplayMonitor* _tmp29_;
							GeeLinkedList* _tmp30_;
							GeeLinkedList* _tmp31_;
							GeeLinkedList* _tmp32_;
							gint _monitor_mode_size = 0;
							GeeLinkedList* _tmp33_;
							gint _tmp34_;
							gint _tmp35_;
							gint _monitor_mode_index = 0;
#line 55 "../src/Utils.vala"
							_tmp29_ = monitor;
#line 55 "../src/Utils.vala"
							_tmp30_ = display_monitor_get_modes (_tmp29_);
#line 55 "../src/Utils.vala"
							_tmp31_ = _tmp30_;
#line 55 "../src/Utils.vala"
							_tmp32_ = _g_object_ref0 (_tmp31_);
#line 55 "../src/Utils.vala"
							_monitor_mode_list = _tmp32_;
#line 55 "../src/Utils.vala"
							_tmp33_ = _monitor_mode_list;
#line 55 "../src/Utils.vala"
							_tmp34_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp33_);
#line 55 "../src/Utils.vala"
							_tmp35_ = _tmp34_;
#line 55 "../src/Utils.vala"
							_monitor_mode_size = _tmp35_;
#line 55 "../src/Utils.vala"
							_monitor_mode_index = -1;
#line 55 "../src/Utils.vala"
							while (TRUE) {
#line 433 "Utils.c"
								DisplayMonitorMode* monitor_mode = NULL;
								GeeLinkedList* _tmp36_;
								gpointer _tmp37_;
								gboolean _tmp38_ = FALSE;
								DisplayMonitorMode* _tmp39_;
								gint _tmp40_;
								gint _tmp41_;
								DisplayMonitorMode* _tmp42_;
								gint _tmp43_;
								gint _tmp44_;
#line 55 "../src/Utils.vala"
								_monitor_mode_index = _monitor_mode_index + 1;
#line 55 "../src/Utils.vala"
								if (!(_monitor_mode_index < _monitor_mode_size)) {
#line 55 "../src/Utils.vala"
									break;
#line 450 "Utils.c"
								}
#line 55 "../src/Utils.vala"
								_tmp36_ = _monitor_mode_list;
#line 55 "../src/Utils.vala"
								_tmp37_ = gee_abstract_list_get ((GeeAbstractList*) _tmp36_, _monitor_mode_index);
#line 55 "../src/Utils.vala"
								monitor_mode = (DisplayMonitorMode*) _tmp37_;
#line 56 "../src/Utils.vala"
								_tmp39_ = mode_to_check;
#line 56 "../src/Utils.vala"
								_tmp40_ = display_monitor_mode_get_width (_tmp39_);
#line 56 "../src/Utils.vala"
								_tmp41_ = _tmp40_;
#line 56 "../src/Utils.vala"
								_tmp42_ = monitor_mode;
#line 56 "../src/Utils.vala"
								_tmp43_ = display_monitor_mode_get_width (_tmp42_);
#line 56 "../src/Utils.vala"
								_tmp44_ = _tmp43_;
#line 56 "../src/Utils.vala"
								if (_tmp41_ == _tmp44_) {
#line 472 "Utils.c"
									DisplayMonitorMode* _tmp45_;
									gint _tmp46_;
									gint _tmp47_;
									DisplayMonitorMode* _tmp48_;
									gint _tmp49_;
									gint _tmp50_;
#line 57 "../src/Utils.vala"
									_tmp45_ = mode_to_check;
#line 57 "../src/Utils.vala"
									_tmp46_ = display_monitor_mode_get_height (_tmp45_);
#line 57 "../src/Utils.vala"
									_tmp47_ = _tmp46_;
#line 57 "../src/Utils.vala"
									_tmp48_ = monitor_mode;
#line 57 "../src/Utils.vala"
									_tmp49_ = display_monitor_mode_get_height (_tmp48_);
#line 57 "../src/Utils.vala"
									_tmp50_ = _tmp49_;
#line 57 "../src/Utils.vala"
									_tmp38_ = _tmp47_ == _tmp50_;
#line 493 "Utils.c"
								} else {
#line 56 "../src/Utils.vala"
									_tmp38_ = FALSE;
#line 497 "Utils.c"
								}
#line 56 "../src/Utils.vala"
								if (_tmp38_) {
#line 58 "../src/Utils.vala"
									mode_found = TRUE;
#line 59 "../src/Utils.vala"
									_g_object_unref0 (monitor_mode);
#line 59 "../src/Utils.vala"
									break;
#line 507 "Utils.c"
								}
#line 55 "../src/Utils.vala"
								_g_object_unref0 (monitor_mode);
#line 511 "Utils.c"
							}
#line 55 "../src/Utils.vala"
							_g_object_unref0 (_monitor_mode_list);
#line 515 "Utils.c"
						}
#line 63 "../src/Utils.vala"
						if (mode_found == FALSE) {
#line 519 "Utils.c"
							GeeLinkedList* _tmp51_;
							DisplayMonitorMode* _tmp52_;
#line 64 "../src/Utils.vala"
							_tmp51_ = to_remove;
#line 64 "../src/Utils.vala"
							_tmp52_ = mode_to_check;
#line 64 "../src/Utils.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp51_, _tmp52_);
#line 528 "Utils.c"
						}
#line 53 "../src/Utils.vala"
						_g_object_unref0 (mode_to_check);
#line 532 "Utils.c"
					}
#line 53 "../src/Utils.vala"
					_g_object_unref0 (_mode_to_check_list);
#line 536 "Utils.c"
				}
#line 68 "../src/Utils.vala"
				_tmp53_ = common_modes;
#line 68 "../src/Utils.vala"
				_tmp54_ = to_remove;
#line 68 "../src/Utils.vala"
				gee_collection_remove_all ((GeeCollection*) _tmp53_, (GeeCollection*) _tmp54_);
#line 43 "../src/Utils.vala"
				_g_object_unref0 (to_remove);
#line 546 "Utils.c"
			}
#line 42 "../src/Utils.vala"
			_g_object_unref0 (monitor);
#line 550 "Utils.c"
		}
#line 42 "../src/Utils.vala"
		_g_object_unref0 (_monitor_list);
#line 554 "Utils.c"
	}
#line 72 "../src/Utils.vala"
	result = common_modes;
#line 72 "../src/Utils.vala"
	return result;
#line 560 "Utils.c"
}

gdouble
display_utils_get_min_compatible_scale (GeeLinkedList* monitors)
{
	gdouble result = 0.0;
	gdouble min_scale = 0.0;
#line 75 "../src/Utils.vala"
	g_return_val_if_fail (monitors != NULL, 0.0);
#line 76 "../src/Utils.vala"
	min_scale = DBL_MAX;
#line 572 "Utils.c"
	{
		GeeLinkedList* _monitor_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _monitor_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _monitor_index = 0;
#line 77 "../src/Utils.vala"
		_tmp0_ = _g_object_ref0 (monitors);
#line 77 "../src/Utils.vala"
		_monitor_list = _tmp0_;
#line 77 "../src/Utils.vala"
		_tmp1_ = _monitor_list;
#line 77 "../src/Utils.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 77 "../src/Utils.vala"
		_tmp3_ = _tmp2_;
#line 77 "../src/Utils.vala"
		_monitor_size = _tmp3_;
#line 77 "../src/Utils.vala"
		_monitor_index = -1;
#line 77 "../src/Utils.vala"
		while (TRUE) {
#line 597 "Utils.c"
			DisplayMonitor* monitor = NULL;
			GeeLinkedList* _tmp4_;
			gpointer _tmp5_;
			DisplayMonitor* _tmp6_;
#line 77 "../src/Utils.vala"
			_monitor_index = _monitor_index + 1;
#line 77 "../src/Utils.vala"
			if (!(_monitor_index < _monitor_size)) {
#line 77 "../src/Utils.vala"
				break;
#line 608 "Utils.c"
			}
#line 77 "../src/Utils.vala"
			_tmp4_ = _monitor_list;
#line 77 "../src/Utils.vala"
			_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, _monitor_index);
#line 77 "../src/Utils.vala"
			monitor = (DisplayMonitor*) _tmp5_;
#line 78 "../src/Utils.vala"
			_tmp6_ = monitor;
#line 78 "../src/Utils.vala"
			min_scale = MIN (min_scale, display_monitor_get_max_scale (_tmp6_));
#line 77 "../src/Utils.vala"
			_g_object_unref0 (monitor);
#line 622 "Utils.c"
		}
#line 77 "../src/Utils.vala"
		_g_object_unref0 (_monitor_list);
#line 626 "Utils.c"
	}
#line 81 "../src/Utils.vala"
	result = min_scale;
#line 81 "../src/Utils.vala"
	return result;
#line 632 "Utils.c"
}

